=== debian/changelog ===
ros-noetic-ergodic-exploration (1.0.0-2buster) buster; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- bostoncleek <bostoncleek2020@u.northwestern.edu>  Tue, 29 Dec 2020 15:50:39 -0000
